with Interfaces; use Interfaces;

package body CORBA_Repository_Root_AttributeDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 16, 46, 33);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (41, 30, 14, 17);

   G : constant array (0 .. 46) of Unsigned_8 :=
     (0, 3, 0, 0, 7, 0, 8, 0, 0, 5, 13, 11, 0, 18, 8, 0, 22, 3, 3, 0, 13, 0,
      0, 0, 0, 11, 10, 7, 7, 0, 6, 0, 0, 0, 0, 4, 0, 0, 1, 1, 7, 0, 0, 0,
      20, 0, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 47;
         F2 := (F2 + Natural (T2 (K)) * J) mod 47;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 23;
   end Hash;

end CORBA_Repository_Root_AttributeDef_Hash;
